Index: ca/pki-ca.el4sol9.spec
===================================================================
--- ca/pki-ca.el4sol9.spec	(revision 16067)
+++ ca/pki-ca.el4sol9.spec	(working copy)
@@ -275,7 +275,7 @@
 %ifos Linux
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 sed -i 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
 mv %{base_component}.jar %{base_component}-%{version}.jar
@@ -284,7 +284,7 @@
 %ifos Solaris
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp 
+cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp 
 cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp | sed 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 rm ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
Index: ca/pki-ca.spec
===================================================================
--- ca/pki-ca.spec	(revision 16067)
+++ ca/pki-ca.spec	(working copy)
@@ -214,7 +214,7 @@
 %install
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 sed -i 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
 mv %{base_component}.jar %{base_component}-%{version}.jar
Index: tks/pki-tks.el4sol9.spec
===================================================================
--- tks/pki-tks.el4sol9.spec	(revision 16067)
+++ tks/pki-tks.el4sol9.spec	(working copy)
@@ -286,7 +286,7 @@
 %ifos Linux
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 sed -i 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
 mv %{base_component}.jar %{base_component}-%{version}.jar
@@ -295,7 +295,7 @@
 %ifos Solaris
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp 
+cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp 
 cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp | sed 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 rm ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
Index: tks/pki-tks.spec
===================================================================
--- tks/pki-tks.spec	(revision 16067)
+++ tks/pki-tks.spec	(working copy)
@@ -225,7 +225,7 @@
 %install
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 sed -i 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
 mv %{base_component}.jar %{base_component}-%{version}.jar
Index: ra/pki-ra.el4sol9.spec
===================================================================
--- ra/pki-ra.el4sol9.spec	(revision 16067)
+++ ra/pki-ra.el4sol9.spec	(working copy)
@@ -267,13 +267,13 @@
 %ifos Linux
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 %endif
 
 %ifos Solaris
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp
+cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp
 mv ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 %endif
 
Index: ra/pki-ra.spec
===================================================================
--- ra/pki-ra.spec	(revision 16067)
+++ ra/pki-ra.spec	(working copy)
@@ -198,7 +198,7 @@
 %install
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 
 
 
Index: ocsp/pki-ocsp.el4sol9.spec
===================================================================
--- ocsp/pki-ocsp.el4sol9.spec	(revision 16067)
+++ ocsp/pki-ocsp.el4sol9.spec	(working copy)
@@ -293,7 +293,7 @@
 %ifos Linux
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 sed -i 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
 mv %{base_component}.jar %{base_component}-%{version}.jar
@@ -302,7 +302,7 @@
 %ifos Solaris
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp 
+cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp 
 cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp | sed 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 rm ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
Index: ocsp/pki-ocsp.spec
===================================================================
--- ocsp/pki-ocsp.spec	(revision 16067)
+++ ocsp/pki-ocsp.spec	(working copy)
@@ -232,7 +232,7 @@
 %install
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 sed -i 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
 mv %{base_component}.jar %{base_component}-%{version}.jar
Index: tps/pki-tps.spec
===================================================================
--- tps/pki-tps.spec	(revision 16067)
+++ tps/pki-tps.spec	(working copy)
@@ -243,7 +243,7 @@
 chmod 00644 ${RPM_BUILD_ROOT}%{_datadir}/doc/%{base_name}-%{base_version}/EULA
 
 ## apply correct product version to CS.cfg
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 
 
 ###############################################################################
Index: tps/pki-tps.el4sol9.spec
===================================================================
--- tps/pki-tps.el4sol9.spec	(revision 16067)
+++ tps/pki-tps.el4sol9.spec	(working copy)
@@ -332,7 +332,7 @@
 chmod 00644 ${RPM_BUILD_ROOT}%{_datadir}/doc/%{base_name}-%{base_version}/EULA
 
 ## apply correct product version to CS.cfg
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 %endif
 
 %ifos Solaris
@@ -349,7 +349,7 @@
 chmod 00644 ${RPM_BUILD_ROOT}%{_datadir}/doc/%{base_name}-%{base_version}/EULA
 
 ## apply correct product version to CS.cfg
-cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp
+cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp
 mv ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 %endif
 
Index: kra/pki-kra.el4sol9.spec
===================================================================
--- kra/pki-kra.el4sol9.spec	(revision 16067)
+++ kra/pki-kra.el4sol9.spec	(working copy)
@@ -284,7 +284,7 @@
 %ifos Linux
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 sed -i 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
 mv %{base_component}.jar %{base_component}-%{version}.jar
@@ -293,7 +293,7 @@
 %ifos Solaris
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp 
+cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg | sed 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp 
 cat ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp | sed 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' > ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 rm ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg.tmp
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
Index: kra/pki-kra.spec
===================================================================
--- kra/pki-kra.spec	(revision 16067)
+++ kra/pki-kra.spec	(working copy)
@@ -223,7 +223,7 @@
 %install
 cd dist/binary
 unzip %{name}-%{version}.zip -d ${RPM_BUILD_ROOT}
-sed -i 's/^preop.product.version=.*$/preop.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
+sed -i 's/^cms.product.version=.*$/cms.product.version=%{pki_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 sed -i 's/^cms.version=.*$/cms.version=%{pki_major_version}.%{pki_minor_version}/' ${RPM_BUILD_ROOT}/usr/share/%{base_prefix}/%{base_component}/conf/CS.cfg
 cd ${RPM_BUILD_ROOT}/usr/share/java/%{base_prefix}/%{base_component}
 mv %{base_component}.jar %{base_component}-%{version}.jar